#ifndef _DEVICE_IO
#define _DEVICE_IO

const int HIGH = 1;
const int LOW = 0;

typedef enum {LSBFIRST, MSBFIRST} ShiftOutMode;
typedef enum {MSBPRE, MSBPOST, LSBPRE, LSBPOST} ShiftInMode;

unsigned int BitSet(unsigned int value, unsigned char bit);

void BitClear(unsigned int value, unsigned char bit);

unsigned char BitRead(unsigned int value, unsigned char bit);

unsigned char BitWrite(unsigned int value, unsigned char bit, unsigned char state);

unsigned char In(unsigned char pin);

void Out(unsigned char pin, unsigned char state);

void SetDIR(unsigned char pin, unsigned char state);

void Delay(unsigned int duration);

void PulseOut(unsigned char pin, unsigned char state, unsigned int duration);

void ShiftOut(unsigned char Dpin, unsigned char Cpin, unsigned int Value, ShiftOutMode Mode, unsigned char bits);

unsigned int ShiftIn(unsigned char Dpin, unsigned char Cpin, ShiftInMode Mode, unsigned char Bits);

void I2C_Init( unsigned char pinDat, unsigned char pinClk );

unsigned char I2C_IsDevPresent( unsigned char devAddr );

unsigned char I2C_ReadAddrPage(unsigned char devAddr, unsigned int reg, unsigned char *bufAddr, unsigned int len);

unsigned char I2C_ReadRegPage(unsigned char devAddr, unsigned char reg, unsigned char *bufAddr, unsigned int len);

unsigned char I2C_ReadPage(unsigned char devAddr, unsigned char *bufAddr, unsigned int len);

unsigned char I2C_WriteAddrPage(unsigned char devAddr, unsigned int reg, unsigned char *bufAddr, unsigned int len);

unsigned char I2C_WriteRegPage(unsigned char devAddr, unsigned char reg, unsigned char *bufAddr, unsigned int len);

unsigned char I2C_WritePage(unsigned char devAddr, unsigned char *bufAddr, unsigned int len);

void SPI_init(unsigned int spi_clk, unsigned int spi_mosi, unsigned int spi_miso, unsigned char spi_mode,unsigned spi_speed);

unsigned int SPI ( unsigned int value, unsigned char bits );

void SPI_Buffer(unsigned int *buffAddr, unsigned char bits, unsigned char len);
#endif // DEVICE_IO
