#include "propeller.h"
void main (int argc,  char* argv[])
{
  Set_DIRA_Group (0,1,1);
  while(1==1)
  {
     if (Get_INA(3) == 0)
     {	     
       Set_OUTA_Group(0,1,1);
     }
     else
     {
       Set_OUTA_Group(0,1,0);
     }
  } 
}

int Set_DIRA(int pin, int state)
{
   int mask;
	
   if (state == 0) 
   {
      DIRA &= Mask(pin, state);
   }
   else
   {
      DIRA |= Mask(pin, state);  
   }
   return state;
}

int Set_OUTA(int pin, int state)
{
   int mask;
	
   if (state == 0) 
   {
      OUTA &= Mask(pin, state);
   }
   else
   {
      OUTA |= Mask(pin, state); 
   }
   return state;
}

int Mask(int pin, int state)
{
   int mask;

   if (state == 0) 
   {
      mask = 0xfffffffe << pin;
   }
   else
   {
      mask = 0x00000001 << pin;	 
   }
   return mask;
}

int Get_INA(int pin)
{
  return (INA >> pin) & 1;
}

int Set_DIRA_Group(int startPin, int endPin, int state)
{
  int i;

  for(i = startPin; i<= endPin; i++)
  {
     Set_DIRA(i, state);
  }
  return state;  
	  
}

int Set_OUTA_Group(int startPin, int endPin, int state)
{
  int i;

  for(i = startPin; i<= endPin; i++)
  {
     Set_OUTA(i, state); 
  }
  return state; 
	  
}

int Get_INA_Group(int startPin, int endPin)
{
   int output;
   int i;

   output = 0;

   for(i = endPin; i >= startPin; i--)
   {
     output |= Get_INA(i);
     output = output <<1;
   }
   return output;
}   	




